<?php
/**
 * Routes configuration
 *
 * In this file, you set up routes to your controllers and their actions.
 * Routes are very important mechanism that allows you to freely connect
 * different urls to chosen controllers and their actions (functions).
 *
 * PHP versions 4 and 5
 *
 * CakePHP(tm) : Rapid Development Framework (http://cakephp.org)
 * Copyright 2005-2010, Cake Software Foundation, Inc. (http://cakefoundation.org)
 *
 * Licensed under The MIT License
 * Redistributions of files must retain the above copyright notice.
 *
 * @copyright     Copyright 2005-2010, Cake Software Foundation, Inc. (http://cakefoundation.org)
 * @link          http://cakephp.org CakePHP(tm) Project
 * @package       cake
 * @subpackage    cake.app.config
 * @since         CakePHP(tm) v 0.2.9
 * @license       MIT License (http://www.opensource.org/licenses/mit-license.php)
 */
/**
 * Here, we are connecting '/' (base path) to controller called 'Pages',
 * its action called 'display', and we pass a param to select the view file
 * to use (in this case, /app/views/pages/home.ctp)...
 */
//	Router::connect('/', array('controller' => 'pages', 'action' => 'display', 'home'));
/**
 * ...and connect the rest of 'Pages' controller's urls.
 */
//	Router::connect('/pages/*', array('controller' => 'pages', 'action' => 'display'));


Router::connect('/', array('controller' => 'top', 'action' => 'index', 'home'));
Router::connect('/admin/manage_groups/:action/*', array('controller' => 'manage_groups'));
Router::connect('/admin/manage_inspects/:action/*', array('controller' => 'manage_inspects'));
Router::connect('/admin/manage_sp_groups/:action/*', array('controller' => 'manage_sp_groups'));
Router::connect('/admin/manage_agreements/:action/*', array('controller' => 'manage_agreements'));
Router::connect('/admin/manage_agencies/:action/*', array('controller' => 'manage_agencies'));

Router::connect('/system/tables/:action/*', array('controller' => 'tables'));
Router::connect('/system/tables/*', array('controller' => 'tables'));
Router::connect('/system/accounts/:action/*', array('controller' => 'system_accounts'));
Router::connect('/system/accounts/*', array('controller' => 'system_accounts'));
Router::connect('/system/statistics/:action/*', array('controller' => 'statistics'));
Router::connect('/system/statistics/*', array('controller' => 'statistics'));
Router::connect('/invites/:action/*', array('controller' => 'invite'));
Router::connect('/rd/*', array('controller' => 'rd', 'action' => 'top'));

//Router::connect('/user/accounts/:action/*', array('controller' => 'accounts'));
//Router::connect('/user/group_lists/:action/*', array('controller' => 'group_lists'));
//Router::connect('/user/groups/:action/*', array('controller' => 'groups'));
//Router::connect('/user/invite/:action/*', array('controller' => 'invite'));
//Router::connect('/user/mygroups/:action/*', array('controller' => 'mygroups'));





