<?php
/**
 * Accounce Component
 *
 * PHP versions 5
 *
 * @copyright     Copyright (c) 2011 - 2012, National Institute of Informatics,
 * @license       BSD License (http://creativecommons.org/licenses/BSD/)
 */
App::import('Core', 'HttpSocket');

class AnnounceComponent extends Object {
	var $file = "tmp/announce.txt";

	/**
	 * meatwikiのmAPお知らせページから情報を取得する。
	 * 前回のページ取得から180秒以上経過していたら再取得する。
	 */
	function getInfo() {
		$info = $this->getAccounceText();
		return trim($info);
	}

	private function getAccounceText() {
		$file = new File($this->file, true);
		$lastTime = $file->lastChange();
		$info = $file->read();
		$file->close();
		if ($lastTime + 180 > time()) {
			return $info;
		}

		$socket = new HttpSocket();
		//$query = array('pageId' => $this->pageId);
		$url = Configure::read("announce.url");
		$query = Configure::read("announce.query");
		$res = $socket->get($url, $query);
		$status_code = $socket->response['status']['code'];
		if ($status_code != 200) {
			$this->log("fail to fetch from $url?" . http_build_query($query) . " (status code: $status_code)", "error");
			return $info;
		}
		if (empty($res)) {
			$file = new File($this->file, true);
//			$info = $file->read();
//			$file->write($info);
			$file->write('');
			$file->close();
			return "";
		}

		$arr = json_decode($res);
		$info = "";
		if (isset($arr->body->anonymous_export_view->value)) {
			$info = $arr->body->anonymous_export_view->value;
		}
		$file = new File($this->file, true);
		$file->write($info);
		$file->close();

		return $info;
	}
}
?>
