<?php
/**
 * FavoriteUpdator Componet
 * MYグループのお気に入りの更新者
 * PHP versions 5
 *
 * @copyright     Copyright (c) 2011 - 2012, National Institute of Informatics,
 * @license       BSD License (http://creativecommons.org/licenses/BSD/)
 */
class FavoriteUpdatorComponent extends Object
{
	var $GroupAccess;
	var $Mygroup;

	function initialize(&$controller) {
		$this->controller =& $controller;
		$this->GroupAccess = ClassRegistry::init('GroupAccess');
		$this->Mygroup = ClassRegistry::init('Mygroup');
	}

	/**
	 * グループのSPリンクのクリック数によって、グループのお気に入り順(表示順)を変更する
	 * @param unknown_type $accountid
	 */
    public function update($accountid) {
    	// ２週間以内にユーザによって、お気に入り順(表示順)が更新されていたら何もしない
		$favoriteDate = $this->Mygroup->findMaxFavoriteByUser($accountid);
		if (strtotime(date('Y-m-d H:i:s', strtotime("-14 day"))) <= strtotime($favoriteDate)) {
			return;
		}

		$groupAccessList = $this->GroupAccess->findAccessOrder($accountid);
    	$time = time();
		foreach ($groupAccessList as $access) {
			$groupid = $access['GroupAccess']['group_id'];
			$this->Mygroup->updateFavoriteOn($accountid, $groupid, $time--, 'system');
		}
    }
}
?>