<?php

class GroupAdministratorComponent extends Object
{
	var $Account;

	function initialize(&$controller) {
		$this->controller =& $controller;
		$this->Account = ClassRegistry::init('Account');
	}

	public function get($groupIds, $lang) {
		if (count($groupIds) == 0) {
			return array();
		}

		$accounts = $this->Account->find('all', array(
			'conditions' => array(),
			'fields' => array('Account.id', 'Account.name', 'Account.name_en', 'Mygroup.groupid'),
			'joins' =>  array(
				array(
					'type' => 'INNER', 'table' => 'mygroups', 'alias' => 'Mygroup',
					'conditions' => array(
						'Account.id = Mygroup.account_id',
						'Mygroup.groupid' => $groupIds,
					),
				),
			),
			'conditions' => array('Mygroup.admin' => array(1, 2)),
			'order' => array('Mygroup.created'),
		));
		$this->controller->removeUnnecessaryLanguage($accounts);

		$group_accounts = array();
		foreach ($accounts as $account) {
			$groupId = $account['Mygroup']['groupid'];
			if (!isset($group_accounts[$groupId])) {
				$group_accounts[$groupId] = array();
			}
			$group_accounts[$groupId][$account['Account']['id']] = $account['Account']['name'].$account['Account']['name_en'];
		}
		return $group_accounts;
	}
}
