<?php
/**
 * Dev Controller
 * dev
 * PHP versions 5
 *
 * @copyright     Copyright (c) 2011 - 2012, National Institute of Informatics,
 * @license       BSD License (http://creativecommons.org/licenses/BSD/)
 */

class DevController extends AppController {
	var $name = 'Dev';
	var $uses = array('AccountEppn', 'Account');
	var $components = array("Session") ;

	function beforeFilter() {
		if (!$this->Common->isDevelopment()) {
			$this->cakeError('notFound', array('url' => $this->here));
		}
	}

	function env() {
		$members = $this->Account->find('all', array(
			'fields'=>array('Account.id', 'Account.name', 'Account.name_en',
					'AccountEppn.eppn', 'AccountEppn.eptid',),
			'joins' =>array(array(
				'type'=>'INNER', 'table'=>'account_eppns', 'alias'=>'AccountEppn',
				'conditions' => array(
					'Account.id = AccountEppn.account_id',
				))
			),
			'order' => array('Account.created ASC'),
			'limit' => 200,
		));
		$this->set('members', $members);
		$this->set('eppn', sprintf('eppn-%s@%s', date('Ymd-His'), $_SERVER['HTTP_HOST']));
	}

	function setenv() {
		if (empty($this->data['eppn']) && empty($this->data['eptid'])) {
			$this->redirect('/dev/env');
		}

		setcookie('eppn', $this->data['eppn'], time() + 60*60*24*365, '/');
		setcookie('persistent-id', $this->data['eptid'], time() + 60*60*24*365, '/');
		$this->redirect('/');
	}

	function login($id) {
		$member = $this->Account->find('first', array(
			'fields'=>array('Account.id', 'Account.name', 'Account.name_en',
					'AccountEppn.eppn', 'AccountEppn.eptid',),
			'joins' =>array(array(
			 	'type'=>'INNER', 'table'=>'account_eppns', 'alias'=>'AccountEppn',
				'conditions' => array(
					'Account.id = AccountEppn.account_id',
					'Account.id' => $id,
				))
			),
		));
		if (!$member) {
			$this->redirect('/dev/env');
		}
		setcookie('eppn', $member['AccountEppn']['eppn'], time() + 60*60*24*365, '/');
		setcookie('persistent-id', $member['AccountEppn']['eptid'], time() + 60*60*24*365, '/');
		$this->redirect('/');
	}

	function _logout() {
		$message = $this->Session->read('beforeLogoutMessage');
		$this->Session->destroy();
		if ($message != '') {
			$this->Session->write('beforeLogoutMessage', $message);
		}
		setcookie('eppn', null, 1, '/');
		setcookie('persistent-id', null, 1, '/');
	}

	function reset() {
		$this->_logout();
		$this->redirect('/dev/env');
	}

	function logout() {
		$this->_logout();
		$this->redirect('/');
	}
}
