<?php
/**
 * RD Controller
 *
 * PHP versions 5
 *
 * @copyright     Copyright (c) 2011 - 2012, National Institute of Informatics,
 * @license       BSD License (http://creativecommons.org/licenses/BSD/)
 */
App::import('Controller', 'GroupLists');

class RdController extends GroupListsController {
	var $name = 'Rd';
	var $uses = array('Group', 'Account', 'AddGroup', 'ProvideAttribute', 'Mygroup');
	var $helpers = array('Attribute');

	/**
	 *
	 * @param integer $id group ID
	 */
	function top(){
		$key = $this->params['pass'][0];
		$this->set('group_key', $key);

		$group = $this->Group->find('first', array('fields' => array('id', 'public'),
			'conditions' => array('group_key' => $key)));
		if (empty($group)) {
			$this->cakeError('notFound', array());
			return;
		}

		$groupid = $group['Group']['id'];
		// セッションにグループIDを入れ、検索対象でないグループも閲覧可能とする
		$this->Session->write('rd_groupid', $groupid);

		if ($this->Group->isGroup($groupid) || $this->Group->isIdPGroup($groupid)) {
			$this->redirect('/group_lists/detail/'.$groupid);
		} elseif ($this->Group->isSpConnector($groupid)) {
			$this->redirect('/sp_groups/detail/'.$groupid);
		} else {
			$this->cakeError('notFound', array());
			return;
		}
	}
}
?>