<?php
/**
 * Redirect Controller
 *
 * PHP versions 5
 *
 * @copyright     Copyright (c) 2011 - 2012, National Institute of Informatics,
 * @license       BSD License (http://creativecommons.org/licenses/BSD/)
 */
class RedirectController extends AppController {
	var $name = 'Redirect';
	var $uses = array('SpAccess', 'GroupAccess', 'GroupSphost');

	function beforeFilter() {
		parent::beforeFilter();
	}

	/**
	 * SPへのリダイレクト
	 */
	function sp($spcid, $groupid) {
		// クリック数を記録する
		$this->GroupAccess->saveAccess($this->getAccountID(), $groupid, $spcid);

		// SPコネクタIDとグループIDから、SPのURLを取得
		$spUrl = $this->GroupSphost->getServiceURL($groupid, $spcid);
		if (empty($spUrl)) {
			$this->redirect('/sp_groups/detail/'.$spcid);
			return;
		}

		$this->SpAccess->updateAccess($this->getAccountID(), $spcid);

		// SPにリダイレクト
		$this->redirect($spUrl);
	}
}
?>