<?php
/**
 * ExtendedAttribute Model
 *
 * PHP versions 5
 *
 * @copyright     Copyright (c) 2019, National Institute of Informatics,
 * @license       BSD License (http://creativecommons.org/licenses/BSD/)
 */
class ExtendedAttribute extends AppModel {
	var $name = 'ExtendedAttribute';
	var $hasMany = array(
		'GroupExtendedValue' => array(
			'className'     => 'GroupExtendedValue',
			'dependent'=> true
		)
	);

	var $validate = array(
		'name' => array(
			'minlength' => array(
				'rule' => array('minLength', '1'),
				'required' => true,
				'message' => 'validation.enter',
			),
			'maxlength' => array(
				'rule' => array('maxLength', '1024'),
				'message' => 'validation.maxlength',
				'last' => true
			),
		),
		'friendly_name' => array(
			'minlength' => array(
				'rule' => array('minLength', '1'),
				'required' => true,
				'message' => 'validation.enter',
			),
			'maxlength' => array(
				'rule' => array('maxLength', '1024'),
				'message' => 'validation.maxlength',
				'last' => true
			),
		),
		'value' => array(
			'minlength' => array(
				'rule' => array('minLength', '1'),
				'required' => true,
				'message' => 'validation.enter',
			),
			'maxlength' => array(
				'rule' => array('maxLength', '1024'),
				'message' => 'validation.maxlength',
				'last' => true
			),
		),
	);}
?>
