<?php
/**
 * GroupAccess Model
 *
 * PHP versions 5
 *
 * @copyright     Copyright (c) 2011 - 2012, National Institute of Informatics,
 * @license       BSD License (http://creativecommons.org/licenses/BSD/)
 */
class GroupAccess extends AppModel
{
    var $name = 'GroupAccess';
    var $useTable = 'group_accesses';

    /**
     * アクセス情報を記録する。
     * @param $accountid アカウントID
     * @param $groupid グループID
     * @param $spcid SPコネクタID
     */
    public function saveAccess($accountid, $groupid, $spcid) {
		$entity = array();
		$entity['account_id'] = $accountid;
		$entity['group_id'] = $groupid;
		$entity['spc_id'] = $spcid;
		$this->save($entity);
    }

    /**
     * アクセス順(多い順)のグループID一覧を取得する
     */
    public function findAccessOrder($accountid) {
		$this->deleteHistory();
		$this->cacheQueries = false;
		$entityList = $this->find('all', array(
			'fields' => array('group_id', 'count(group_id) as count'),
			'conditions' => array('account_id' => $accountid),
			'group' => array('group_id'),
			'order' => array('count DESC', 'group_id ASC')));
		$this->cacheQueries = true;
		return $entityList;
    }


    /**
     * 古い(１週間)レコードを削除する
     */
    private function deleteHistory() {
		$this->deleteAll(array('created <= DATE_SUB(NOW(), interval 7 day)'), false);
    }
}
?>