<?php
/**
 * Group Model
 *
 * PHP versions 5
 *
 * @copyright     Copyright (c) 2011 - 2012, National Institute of Informatics,
 * @license       BSD License (http://creativecommons.org/licenses/BSD/)
 */
App::import('Model', 'Group');

class GroupAgency extends Group {
    var $name = 'Group';
    var $validate = array(
        'name' => array(
    		'maxlength' => array(
            	'rule' => array('maxLength', '50'),
          		'message' => 'validation.maxlength',
            	'last' => true
          	),
          	'duplication' => array(
		        'rule' => array('duplicateGroupName'),
         		'message' => 'validation.duplication.group',
	    	),
        ),
        'name_en' => array(
    		'maxlength' => array(
            	'rule' => array('maxLength', '50'),
          		'message' => 'validation.maxlength',
            	'last' => true
          	),
    		'duplication' => array(
		        'rule' => array('duplicateGroupNameEn'),
         		'message' => 'validation.duplication.group',
	    	),
        ),
        'name_require' => array(
    		'require' => array(
	          	'rule' => array('requireGroupName'),
	        	'message' => 'validation.enter',
	          	'last' => true
          	),
        ),
        'group_key' => array(
    		'minlength' => array(
            	'rule' => array('minLength', '4'),
    			'message' => 'validation.minlength',
            	'last' => true
          	),
    		'maxlength' => array(
            	'rule' => array('maxLength', '2048'),
          		'message' => 'validation.maxlength',
            	'last' => true
          	),
//    		'alphanumeric' => array(
//            	'rule' => array('custom', '/^[a-z\d._-]+$/i'),
//				'message' => 'validation.alphanumeric',
//          		'last' => true
//         	),
    		'duplication' => array(
		        'rule' => array('duplicateGroupKey'),
         		'message' => 'validation.duplication.group.key',
	    	),
        ),
        'introduction' => array(
    		'maxlength' => array(
            	'rule' => array('maxLength', '200'),
        		'message' => 'validation.maxlength',
            	'last' => true
          	),
        ),
        'introduction_en' => array(
    		'maxlength' => array(
            	'rule' => array('maxLength', '200'),
        		'message' => 'validation.maxlength',
            	'last' => true
          	),
        ),
        'introduction_require' => array(
    		'require' => array(
	          	'rule' => array('requireIntroduction'),
	        	'message' => 'validation.enter',
	          	'last' => true
          	),
        ),
	);
}
?>
