<?php
/**
 * ProvideAttribute Model
 *
 * PHP versions 5
 *
 * @copyright     Copyright (c) 2011 - 2012, National Institute of Informatics,
 * @license       BSD License (http://creativecommons.org/licenses/BSD/)
 */
class ProvideAttribute extends AppModel
{
    var $name = 'ProvideAttribute';

    /**
     * 利用属性一覧を取得する
     */
    function getProviteAttributeList($spcid) {
		$attribute = $this->find('first', array('conditions' => array('group_id' => $spcid)));
		if (empty($attribute))
			return array();

		$list = array();
		if ($attribute['ProvideAttribute']['ismemberof']) {
			$list['ismemberof'] = true;
		}
		if ($attribute['ProvideAttribute']['eptid']) {
			$list['eptid'] = true;
		}
		if ($attribute['ProvideAttribute']['name']) {
			$list['name'] = true;
		}
		if ($attribute['ProvideAttribute']['mail']) {
			$list['mail'] = true;
		}
		if ($attribute['ProvideAttribute']['eppn']) {
			$list['eppn'] = true;
		}
		if ($attribute['ProvideAttribute']['idp']) {
			$list['idp'] = true;
		}
		if ($attribute['ProvideAttribute']['introduction']) {
			$list['introduction'] = true;
		}
		if ($attribute['ProvideAttribute']['language']) {
			$list['language'] = true;
		}
		if ($attribute['ProvideAttribute']['organization']) {
			$list['organization'] = true;
		}
		return $list;
    }

    /**
     * isMemberOf属性を利用するSPコネクタIDの一覧を検索します。
     */
    public function findIsMemberOfSPConnector() {
		$list = $this->find('list', array('fields' => array('group_id', 'group_id'),
			'conditions' => array('ismemberof' => 1)));
    	return $list;
    }
}
?>
