<?php
/**
 * SpAccess Model
 *
 * PHP versions 5
 *
 * @copyright     Copyright (c) 2011 - 2012, National Institute of Informatics,
 * @license       BSD License (http://creativecommons.org/licenses/BSD/)
 */
class SpAccess extends AppModel
{
    var $name = 'SpAccess';
    var $useTable = 'sp_accesses';

	/**
	 * SPへのアクセス情報を記録します
	 * @param $userid ユーザID
	 * @param $scpid SPコネクタID
	 */
	function updateAccess($userid, $spcid) {
		$entity =  $this->find('first', array(
			'conditions' => array('account_id' => $userid, 'spc_id' => $spcid)));
		$total = 0;
		if (empty($entity)) {
			$this->create();
			$entity = array();
			$entity['SpAccess']['account_id'] = $userid;
			$total = 1;
		} else {
			$total = $entity['SpAccess']['total'] + 1;
		}
		$entity['SpAccess']['spc_id'] = $spcid;
		$entity['SpAccess']['total'] = $total;
		$entity['SpAccess']['modified'] = null;
		$this->save($entity);
	}

	/**
	 * SPへのアクセス頻度順のSPコネクタIDを検索します
	 */
	function findOrderAccessCount($userid) {
		$list = $this->find('list', array(
			'fields' => array('spc_id', 'spc_id'),
			'conditions' => array('account_id' => $userid),
			'order' => array('total DESC')));
		return $list;
	}

	/**
	 * SPへの最終アクセス順のSPコネクタIDを検索します
	 */
	function findOrderLastAccess($userid) {
		$list = $this->find('list', array(
			'fields' => array('spc_id', 'spc_id'),
			'conditions' => array('account_id' => $userid),
			'order' => array('modified DESC')));
		return $list;
	}
}
?>