<?php
/**
 * SpHost Model
 *
 * PHP versions 5
 *
 * @copyright     Copyright (c) 2011 - 2012, National Institute of Informatics,
 * @license       BSD License (http://creativecommons.org/licenses/BSD/)
 */
class SpHost extends AppModel
{
    var $name = 'SpHost';

    /**
     * SPのホスト部を取得します。
     * @param $spid
     */
	function getSpHost($spid) {
		$entity = $this->find('first', array(
			'fields' => array('name'),
			'conditions' => array('id' => $spid)));
		if (empty($entity)) {
			return '';
		}
		return $entity['SpHost']['name'];
	}

	/**
	 * SPのホスト部一覧を取得します。
	 * @param $spid
	 */
	function getSpHostList() {
		$list = $this->find('list', array(
				'fields' => array('id', 'name')));
		return $list;
	}

	/**
	 * 有効なデータをすべて取得します。
	 */
	function getEffectiveAllList($today) {
		$list = $this->find('all', array(
				'conditions'=> array('status' => 0, 'valid_util >= ?' => $today)));
		return $list;
	}

	/**
	 * エンティティIDに該当するSPIDを取得します。
	 */
	function getSpId($entityId) {
		$entity = $this->find('first', array('conditions'=> array('entityid' => $entityId, 'status' => 0)));
		if (empty($entity)) {
			return false;
		}
		return $entity['SpHost']['id'];
	}

	/**
	 * SPの証明書が一致する検証します。
	 */
	function verifyCertificate($spid, $cert) {
		if ($this->find('count', array('conditions' => array(
				'id' => $spid,
				'OR' => array('certificate' => $cert, 'certificate2' => $cert)))) == 0) {
			return false;
		}
		return true;
	}
}
?>
