<?php
/**
 * Attribute Helper
 *
 * PHP versions 5
 *
 * @copyright     Copyright (c) 2011 - 2012, National Institute of Informatics,
 * @license       BSD License (http://creativecommons.org/licenses/BSD/)
 */
class AttributeHelper extends AppHelper
{
	function toShowAttributeList($provideAttribute) {
		if (empty($provideAttribute)) {
			return array();
		}

		$attributeList = array();
		if (isset($provideAttribute[0])) {
			foreach ($provideAttribute as $attribute) {
				$this->setArray($attributeList, $attribute);
			}
		} else {
			$this->setArray($attributeList, $provideAttribute);
		}

		return $attributeList;
	}

	private function setArray(&$attributeList, $provideAttribute) {
		if ($provideAttribute['ProvideAttribute']['ismemberof']) {
			$attributeList['ismemberof'] = __('common.group.id', true);
		}
		if ($provideAttribute['ProvideAttribute']['eptid']) {
			$attributeList['eptid'] = __('common.eptid', true);
		}
		if ($provideAttribute['ProvideAttribute']['name']) {
			$attributeList['name'] = __('common.name', true);
		}
		if ($provideAttribute['ProvideAttribute']['mail']) {
			$attributeList['mail'] = __('common.mailaddress', true);
		}
		if ($provideAttribute['ProvideAttribute']['eppn']) {
			$attributeList['eppn'] = __('common.eppn', true);
		}
		if ($provideAttribute['ProvideAttribute']['idp']) {
			$attributeList['idp'] =  __('common.affiliation.idp', true);
		}
		if ($provideAttribute['ProvideAttribute']['introduction']) {
			$attributeList['introduction'] = __('common.my.introduction', true);
		}
		if ($provideAttribute['ProvideAttribute']['language']) {
			$attributeList['language'] = __('common.language', true);
		}
	}
}
?>
