DROP TABLE IF EXISTS `accounts`;
CREATE TABLE  `accounts` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `name_en` varchar(50) default NULL,
  `mail` varchar(255) default NULL,
  `university` varchar(100) default NULL,
  `university_en` varchar(100) default NULL,
  `introduction` varchar(200) default NULL,
  `introduction_en` varchar(200) default NULL,
  `language` varchar(50) default NULL,
  `agreement` varchar(10) default NULL,
  `arrival` int(1) default 0,
  `arrival_key` varchar(50) default NULL,
  `arrival_time` datetime default NULL,
  `import` varchar(20) default NULL,
  `temp_groupid` int default NULL,
  `is_temp` int(1) default 0,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  `show_unusable` int(1) default 0,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `account_eppns`;
CREATE TABLE  `account_eppns` (
  `id` int unsigned NOT NULL auto_increment,
  `account_id` int default NULL,
  `eppn` varchar(256) default NULL,
  `eptid` varchar(256) default NULL,
  `entityid` varchar(255) default NULL,
  `local_id` varchar(255) default NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  `last_login_approx` datetime default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `account_attributes`;
CREATE TABLE  `account_attributes` (
  `id` int unsigned NOT NULL auto_increment,
  `account_id` int default NULL,
  `entityid` varchar(255) default NULL,
  `o` varchar(200) default NULL,
  `ou` varchar(200) default NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `account_integrations`;
CREATE TABLE  `account_integrations` (
  `id` int unsigned NOT NULL auto_increment,
  `random_key` varchar(50) default NULL,
  `account_id` int default NULL,
  `copy_account_id` int default NULL,
  `copy_eppn` varchar(256) default NULL,
  `copy_eptid` varchar(256) default NULL,
  `copy_entityid` varchar(255) default NULL,
  `status` varchar(20) default NULL,
  `created` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `agreements`;
CREATE TABLE  `agreements` (
  `id` int unsigned NOT NULL auto_increment,
  `account_id` int default NULL,
  `group_id` int default NULL,
  `eptid` smallint default 0,
  `name` smallint default 0,
  `mail` smallint default 0,
  `eppn` smallint default 0,
  `idp` smallint default 0,
  `introduction` smallint default 0,
  `language` smallint default 0,
  `organization` smallint default 0,
  `before_eptid` smallint default 0,
  `before_name` smallint default 0,
  `before_mail` smallint default 0,
  `before_eppn` smallint default 0,
  `before_idp` smallint default 0,
  `before_introduction` smallint default 0,
  `before_language` smallint default 0,
  `before_organization` smallint default 0,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `agreement_ismemberofs`;
CREATE TABLE  `agreement_ismemberofs` (
  `id` int unsigned NOT NULL auto_increment,
  `account_id` int default NULL,
  `spc_id` int default NULL,
  `group_id` int default NULL,
  `ismemberof` smallint default 0,
  `before_ismemberof` smallint default 0,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `agreement_connects`;
CREATE TABLE  `agreement_connects` (
  `id` int unsigned NOT NULL auto_increment,
  `spc_id` int default NULL,
  `top_group_id` int default NULL,
  `bottom_group_id` int default NULL,
  `status` int default 0,
  `add_attributes` varchar(200) default NULL,
  `add_sps` varchar(200) default NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `agreement_entrustments`;
CREATE TABLE  `agreement_entrustments` (
  `id` int unsigned NOT NULL auto_increment,
  `group_id` int default NULL,
  `account_id` int default NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `provide_attributes`;
CREATE TABLE  `provide_attributes` (
  `id` int unsigned NOT NULL auto_increment,
  `group_id` int default NULL,
  `ismemberof` smallint default 0,
  `eptid` smallint default 0,
  `name` smallint default 0,
  `mail` smallint default 0,
  `eppn` smallint default 0,
  `idp` smallint default 0,
  `introduction` smallint default 0,
  `language` smallint default 0,
  `organization` smallint default 0,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `inspect_attributes`;
CREATE TABLE  `inspect_attributes` (
  `id` int unsigned NOT NULL auto_increment,
  `inspect_id` int default NULL,
  `from_group_id` int default NULL,
  `to_group_id` int default NULL,
  `ismemberof` smallint default 0,
  `eptid` smallint default 0,
  `name` smallint default 0,
  `mail` smallint default 0,
  `eppn` smallint default 0,
  `idp` smallint default 0,
  `introduction` smallint default 0,
  `language` smallint default 0,
  `organization` smallint default 0,
  `status` int default NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `groups`;
CREATE TABLE  `groups` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `group_key` varchar(2048) NULL,
  `name` varchar(500) default NULL,
  `name_en` varchar(50) default NULL,
  `name_en_normalization` varchar(50) default NULL,
  `introduction` varchar(512) default NULL,
  `introduction_en` varchar(256) default NULL,
  `contactadmin` varchar(200) default NULL,
  `contactmember` varchar(200) default NULL,
  `active` int(1) default '0',
  `public` int(1) default '1',
  `openmember` int(1) default '1',
  `inspectjoin` int(1) default '0',
  `inspectquit` int(1) default '0',
  `independence` int(1) default '0',
  `down_permission` int(1) default '0',
  `up_permission` int(1) default '0',
  `group_response` int(1) default '0',
  `sp` int(2) default '0',
  `sp_type` int(1) default NULL,
  `lead_url` varchar(200) default NULL,
  `lead_non_map_url` varchar(200) default NULL,
  `spc_icon` varchar(100) default NULL,
  `spc_icon_type` varchar(16) default 'png',
  `spc_icon_logo` int(1) default 0,
  `icon` int(2) unsigned default 1,
  `icon_type` varchar(16) default 'png',
  `created` datetime default NULL,
  `modified` datetime default NULL,
  `link_for_idp_administrator` varchar(1024) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `group_sphosts`;
CREATE TABLE  `group_sphosts` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `group_id` int(11) NOT NULL,
  `sp_id` int(11) NOT NULL,
  `service_name` varchar(100) NULL,
  `service_name_en` varchar(100) NULL,
  `lead_url` varchar(1024) NULL,
  `callback_url` VARCHAR(1024) default NULL,
  `logout_option` varchar(20) NULL,
  `relogin_url` varchar(1024) NULL,
  `service_link_both` varchar(10) NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  `lead_non_map_url` varchar(1024) NULL,
  `auto` int(1) default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `auto_groups`;
CREATE TABLE  `auto_groups` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `o` varchar(200) default NULL,
  `ou` varchar(200) default NULL,
  `idp` varchar(20) default NULL,
  `entityid` varchar(255) default NULL,
  `group_id` int(11) default NULL,
  `status` varchar(20) default NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  `certificate` varchar(4096) default NULL,
  `certificate2` varchar(4096) default NULL,
  `scope` varchar(256) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `auto_group_key_sequences`;
CREATE TABLE auto_group_key_sequences (id int NOT NULL);
INSERT INTO auto_group_key_sequences VALUES (0);

DROP TABLE IF EXISTS `inspects`;
CREATE TABLE  `inspects` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `account_id` int default NULL,
  `groupid` int(11) default NULL,
  `kind` tinyint(1) default NULL,
  `status` tinyint(1) default NULL,
  `result` varchar(20) default NULL,
  `sent` int(1) default NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `invites`;
CREATE TABLE  `invites` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `account_id` int default NULL,
  `groupid` int(11) default NULL,
  `random` varchar(50) binary default NULL,
  `address` varchar(255) default NULL,
  `term` varchar(10) default NULL,
  `status` int default NULL,
  `counter` int default 0,
  `body` varchar(4000) default NULL,
  `language` varchar(50) default NULL,
  `resend_id` int default NULL,
  `invited_account_id` int default NULL,
  `temp_account_id` int default NULL,
  `forcible` int default 0,
  `joined_account_id` int default NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `groupid_random_uk` (`groupid`, `random`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `mygroups`;
CREATE TABLE  `mygroups` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `account_id` int default NULL,
  `groupid` int(11) default NULL,
  `admin` int(1) default '0',
  `favorite` datetime default NULL,
  `favorite_updator` varchar(20) default NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



DROP TABLE IF EXISTS `add_group_inspects`;
CREATE TABLE  `add_group_inspects` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `account_id` int default NULL,
  `top_id` int(11) default NULL,
  `bottom_id` int(11) default NULL,
  `to_id` int(11) default NULL,
  `from_id` int(11) default NULL,
  `top` int(1) default NULL,
  `bottom` int(1) default NULL,
  `join` int(1) default NULL,
  `kind` int(1) default NULL,
  `status` int(1) default NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



DROP TABLE IF EXISTS `sp_hosts`;
CREATE TABLE  `sp_hosts` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `entityid` varchar(255) NULL,
  `name` varchar(100) NOT NULL,
  `service_name` varchar(100) NULL,
  `service_name_en` varchar(100) NULL,
  `status` tinyint(1) default NULL,
  `valid_util` varchar(50) NULL,
  `certificate` varchar(4096) NULL,
  `certificate2` varchar(4096) NULL,
  `description`	varchar(512) NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



DROP TABLE IF EXISTS `sp_administrators`;
CREATE TABLE  `sp_administrators` (
  `id` int unsigned NOT NULL auto_increment,
  `eppn` varchar(256) NULL,
  `eptid` varchar(256) NULL,
  `host_name` varchar(100) NULL,
  `entityid` varchar(255) NOT NULL,
  `created` datetime default NULL,
   PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `idp_administrators`;
CREATE TABLE  `idp_administrators` (
  `id` int unsigned NOT NULL auto_increment,
  `eppn` varchar(256) default NULL,
  `eptid` varchar(256) default NULL,
  `entityid` varchar(255) default NULL,
  `created` datetime default NULL,
   PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `add_groups`;
CREATE TABLE  `add_groups` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `top_id` int(11) default NULL,
  `bottom_id` int(11) default NULL,
  `top` int(1) default NULL,
  `bottom` int(1) default NULL,
  `auto` int(1) default NULL,
  `created` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `organizations`;
CREATE TABLE  `organizations` (
  `id` int unsigned NOT NULL auto_increment,
  `name` varchar(200) NULL,
  `name_en` varchar(200) NULL,
  `display_name` varchar(200) NULL,
  `display_name_en` varchar(200) NULL,
  `entityid` varchar(255) NULL,
  `federation` int NULL,
  `valid_util` varchar(50) NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



/*  map-idp側で StoredID を利用するために必要 */
/* Shibboleth IdP 2系の設定 */
/* @see https://wiki.shibboleth.net/confluence/display/SHIB2/StoredIDDataConnectorDDL */
/*
CREATE TABLE IF NOT EXISTS shibpid (
  localEntity TEXT NOT NULL,
  peerEntity TEXT NOT NULL,
  principalName VARCHAR(255) NOT NULL default '',
  localId VARCHAR(255) NOT NULL,
  persistentId VARCHAR(36) NOT NULL,
  peerProvidedId VARCHAR(255) default NULL,
  creationDate timestamp NOT NULL default CURRENT_TIMESTAMP
   on update CURRENT_TIMESTAMP,
  deactivationDate timestamp NULL default NULL,
  KEY persistentId (persistentId),
  KEY persistentId_2 (persistentId, deactivationDate),
  KEY localEntity (localEntity(16), peerEntity(16), localId),
  KEY localEntity_2 (localEntity(16), peerEntity(16),
  localId, deactivationDate)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* Shibboleth IdP 3系の設定 */
/* @see https://wiki.shibboleth.net/confluence/display/IDP30/PersistentNameIDGenerationConfiguration */
CREATE TABLE shibpid (
    localEntity VARCHAR(255) NOT NULL,
    peerEntity VARCHAR(255) NOT NULL,
    persistentId VARCHAR(50) NOT NULL,
    principalName VARCHAR(255) NOT NULL,
    localId VARCHAR(50) NOT NULL,
    peerProvidedId VARCHAR(50) NULL,
    creationDate TIMESTAMP NOT NULL,
    deactivationDate TIMESTAMP NULL,
    PRIMARY KEY (localEntity, peerEntity, persistentId)
);
/* ↓ cakephpで操作するために必要 */
ALTER TABLE shibpid ADD id int unsigned NOT NULL;
ALTER TABLE shibpid CHANGE column id id int unsigned not null auto_increment, add index (id);
/*ALTER TABLE shibpid ADD PRIMARY KEY (id);*/


DROP TABLE IF EXISTS `sp_auto_connectors`;
CREATE TABLE  `sp_auto_connectors` (
  `id` int unsigned NOT NULL auto_increment,
  `groupid` int default NULL,
  `created` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `spc_sorts`;
CREATE TABLE  `spc_sorts` (
  `id` int unsigned NOT NULL auto_increment,
  `account_id` int NOT NULL,
  `groupid` int NOT NULL,
  `sort_type` varchar(20) NOT NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE(`account_id`, `groupid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `sp_accesses`;
CREATE TABLE  `sp_accesses` (
  `id` bigint unsigned NOT NULL auto_increment,
  `account_id` int default NULL,
  `spc_id` int NOT NULL,
  `total` bigint NOT NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE(`account_id`, `spc_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `group_admin_sp_sorts`;
CREATE TABLE  `group_admin_sp_sorts` (
  `id` int unsigned NOT NULL auto_increment,
  `groupid` int NOT NULL,
  `spc_id_list` varchar(4000) NULL,
  `modified_account_id` int default NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE(`groupid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `user_sp_sorts`;
CREATE TABLE  `user_sp_sorts` (
  `id` int unsigned NOT NULL auto_increment,
  `account_id` int default NULL,
  `groupid` int NOT NULL,
  `left_spc_id_list` varchar(4000) NULL,
  `right_spc_id_list` varchar(4000) NULL,
  `center_spc_id_list` varchar(4000) NULL,
  `spc_id_list` varchar(4000) NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE(`account_id`, `groupid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `spconnector_kinds`;
CREATE TABLE  `spconnector_kinds` (
  `id` int unsigned NOT NULL auto_increment,
  `spcid` int NOT NULL,
  `kind` varchar(20) NULL,
  `color` varchar(20) NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE(`spcid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `group_accesses`;
CREATE TABLE  `group_accesses` (
  `id` bigint unsigned NOT NULL auto_increment,
  `account_id` int default NULL,
  `group_id` int NOT NULL,
  `spc_id` int NOT NULL,
  `created` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tags`;
CREATE TABLE  `tags` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `group_id` int(11) NOT NULL,
  `account_id` int(12) NOT NULL,
  `name` varchar(100) NOT NULL,
  `public` int(1) default '0',
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE  `icon_images` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `group_id` int(11) NOT NULL,
  `size` int(11) NOT NULL,
  `last_change` int(11) NOT NULL,
  `image` mediumblob NOT NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `extended_attributes`;
CREATE TABLE  `extended_attributes` (
  `id` int unsigned NOT NULL auto_increment,
  `spc_id` int NOT NULL,
   `kind` smallint default 0,
  `name` varchar(1024) NOT NULL,
  `friendly_name` varchar(1024) NOT NULL,
  `value` varchar(1024) default NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `group_extended_values`;
CREATE TABLE  `group_extended_values` (
  `id` int unsigned NOT NULL auto_increment,
  `group_id` int NOT NULL,
  `extended_attribute_id` int NOT NULL,
  `value` varchar(1024) NOT NULL,
  `created` datetime default NULL,
  `modified` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `add_groups_spc_logs`;
CREATE TABLE  `add_groups_spc_logs` (
  `id` int unsigned NOT NULL auto_increment,
  `kind` tinyint(1) default 0,
  `group_id` int NOT NULL,
  `spc_id` int NOT NULL,
  `add_group_id` int NOT NULL,
  `account_id` int default NULL,
  `auto` tinyint(1) default NULL,
  `sp_driven` tinyint(1) default NULL,
  `add_group_inspect_id` int default NULL,
  `created` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `sent_notice_mail_logs`;
CREATE TABLE IF NOT EXISTS `sent_notice_mail_logs` (
  `id` int unsigned NOT NULL auto_increment,
  `account_eppn_id` int(11) NOT NULL,
  `kind` smallint(6) NOT NULL default 1,
  `random` varchar(50) binary default NULL,
  `sent` datetime default NULL,
  `accessed` datetime default NULL,
  `pending` tinyint(1) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE(`random`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

