/* インデックス */

/* account */
CREATE INDEX idx_accounts_arrival ON accounts(arrival, mail);
CREATE INDEX idx_account_import ON accounts(import);
CREATE INDEX idx_account_temp_groupid ON accounts(temp_groupid);


/* account_eppns */
CREATE INDEX idx_account_eppns_eppn ON account_eppns(eppn);
CREATE INDEX idx_account_eppns_eptid ON account_eppns(eptid);
CREATE INDEX idx_account_eppns_account_id ON account_eppns(account_id);
CREATE INDEX idx_account_eppns_local_id ON account_eppns(local_id);

/* account_integrations */
CREATE INDEX idx_account_integrations_key ON account_integrations(random_key);

/* account_attributes */
CREATE INDEX idx_account_attributes_account_id ON account_attributes(account_id);

/* groupsテーブル */
CREATE INDEX idx_groups_introduction ON groups(introduction);
CREATE INDEX idx_groups_introduction_en ON groups(introduction_en);
CREATE INDEX idx_groups_active_public ON groups(active, public);
CREATE INDEX idx_groups_sp ON groups(sp);
CREATE INDEX idx_groups_name ON groups(name);
CREATE INDEX idx_groups_name_en ON groups(name_en);
CREATE INDEX idx_groups_group_key ON groups(group_key);
CREATE INDEX idx_groups_name_en_normalization ON groups(name_en_normalization);

/* group_categoriesテーブル */
CREATE INDEX idx_group_categories_ids ON group_categories(group_id, category_id);

/* auto_groupsテーブル */
CREATE INDEX idx_auto_groups_o ON auto_groups(o);
CREATE INDEX idx_auto_groups_ou ON auto_groups(ou);
CREATE INDEX idx_auto_groups_entityid ON auto_groups(entityid);


/* sp_administrators */
CREATE INDEX idx_sp_administrators_eppn ON sp_administrators(eppn);

/* mygroups */
CREATE INDEX idx_mygroups_account_id ON mygroups(account_id);
CREATE INDEX idx_mygroups_groupid ON mygroups(groupid);


/* invites */
CREATE INDEX idx_invites_eppn ON invites(account_id);
CREATE INDEX idx_invites_groupid ON invites(groupid);
CREATE INDEX idx_invites_regist ON invites(random, groupid, address, status);


/* sp_hosts */
CREATE INDEX idx_sp_hosts_name ON sp_hosts(name);
CREATE INDEX idx_sp_hosts_entityid ON sp_hosts(entityid);
CREATE INDEX idx_sp_hosts_certificate ON sp_hosts(certificate, certificate2);

/* group_sphosts */
CREATE INDEX idx_group_sphosts_group_id ON group_sphosts(group_id);
CREATE INDEX idx_group_sphosts_service_name ON group_sphosts(service_name);
CREATE INDEX idx_group_sphosts_sp_id ON group_sphosts(sp_id);

/* add_groups */
CREATE INDEX idx_add_groups_top_id ON add_groups(top_id);
CREATE INDEX idx_add_groups_bottom_id ON add_groups(bottom_id);

/* organizations */
CREATE INDEX idx_organizations_entityid ON organizations(entityid);

/* inspects */
CREATE INDEX idx_inspects_ids ON inspects(groupid, account_id);

/* add_group_inspects */
CREATE INDEX idx_add_group_inspects_ids ON add_group_inspects(top_id, bottom_id);

/* agreements */
CREATE INDEX idx_agreements_ids ON agreements(account_id, group_id);

/* agreement_ismemberofs */
CREATE INDEX idx_agreement_ismemberofs_find ON agreement_ismemberofs(account_id, spc_id, group_id);

/* agreement_connects */
CREATE INDEX idx_agreement_connects_find ON agreement_connects(spc_id, top_group_id, bottom_group_id, status);

/* agreement_entrustments */
CREATE INDEX idx_agreement_entrustments_find ON agreement_entrustments(group_id, account_id);

/* provide_attributes */
CREATE INDEX idx_provide_attributes_group_id ON provide_attributes(group_id);

/* inspect_id*/
CREATE INDEX idx_inspect_attributes_inspect_id ON inspect_attributes(inspect_id);

/* spc_sorts */
CREATE INDEX idx_spc_sorts_account_id ON spc_sorts(account_id);

/* group_accesses */
CREATE INDEX idx_group_accesses_account_group ON group_accesses(account_id,group_id);
CREATE INDEX idx_group_accesses_created ON group_accesses(created);

/* extended_attributes */
CREATE INDEX idx_extended_attributes_spc_id ON extended_attributes(spc_id);
CREATE INDEX idx_extended_attributes_find ON extended_attributes(spc_id, kind);

/* group_extended_values */
CREATE INDEX idx_group_extended_values_group_id ON group_extended_values(group_id);
CREATE INDEX idx_group_extended_values_ids ON group_extended_values(group_id, extended_attribute_id);

/* インデックスの再構築 */
ALTER TABLE account_attributes ENGINE=InnoDB;
ALTER TABLE account_eppns ENGINE=InnoDB;
ALTER TABLE account_integrations ENGINE=InnoDB;
ALTER TABLE accounts ENGINE=InnoDB;
ALTER TABLE add_group_inspects ENGINE=InnoDB;
ALTER TABLE add_groups ENGINE=InnoDB;
ALTER TABLE agreement_connects ENGINE=InnoDB;
ALTER TABLE agreement_entrustments ENGINE=InnoDB;
ALTER TABLE agreement_ismemberofs ENGINE=InnoDB;
ALTER TABLE agreements ENGINE=InnoDB;
ALTER TABLE auto_groups ENGINE=InnoDB;
ALTER TABLE categories ENGINE=InnoDB;
ALTER TABLE group_categories ENGINE=InnoDB;
ALTER TABLE group_sphosts ENGINE=InnoDB;
ALTER TABLE groups ENGINE=InnoDB;
ALTER TABLE idp_administrators ENGINE=InnoDB;
ALTER TABLE inspect_attributes ENGINE=InnoDB;
ALTER TABLE inspects ENGINE=InnoDB;
ALTER TABLE invites ENGINE=InnoDB;
ALTER TABLE mygroups ENGINE=InnoDB;
ALTER TABLE organizations ENGINE=InnoDB;
ALTER TABLE provide_attributes ENGINE=InnoDB;
ALTER TABLE sp_administrators ENGINE=InnoDB;
ALTER TABLE sp_hosts ENGINE=InnoDB;
ALTER TABLE tmp_ismemberof ENGINE=InnoDB;
ALTER TABLE spc_sorts ENGINE=InnoDB;
ALTER TABLE sp_accesses ENGINE=InnoDB;
ALTER TABLE group_accesses ENGINE=InnoDB;
ALTER TABLE extended_attributes ENGINE=InnoDB;
ALTER TABLE group_extended_values ENGINE=InnoDB;


